use std::collections::HashSet;
use std::fs::read_to_string;

fn find_marker(content: &str, size: usize) -> Option<usize> {
    for (idx, chars) in content.chars().collect::<Vec<_>>().windows(size).enumerate() {
        let set = chars.iter().map(|char|*char).collect::<HashSet<_>>();
        if set.len() == size {
            let idx = idx + size;
            return Some(idx);
        }
    }
    None
}

fn main() {
    let content = read_to_string("day6.txt").unwrap();

    println!("Task 1: {}", find_marker(&content, 4).unwrap());
    println!("Task 2: {}", find_marker(&content, 14).unwrap());

}